/******************************************************************************/
/*   Copyright (C) 1996 K. Vasudevan. Indian Institute of Technology Madras.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
/******************************************************************************/
/*                        FILE POINTER VARIABLES.
*******************************************************************************/
extern FILE *fp1,*fp2,*fp3,*fp4,*fp5,*fp6,*fp7;             /* File pointers. */
/******************************************************************************/
/*                        ERROR COUNTER VARIABLE.
*******************************************************************************/
extern long Err_Cnt;                          /* Counts the number of errors. */
/******************************************************************************/
/*                           COUNTER VARIABLES.
*******************************************************************************/
extern long Symcnt;                                   /* Symbols transmitted. */
extern long V_Sym_Cnt;                          /* Valid symbols transmitted. */
extern int Ipcnt;                                     /* Interpolation index. */
/******************************************************************************/
/*              VARIABLES RELATED TO THE SAMPLING FREQUENCY.
*******************************************************************************/
extern double F_s_Tx_Flt;       /* Sampling frequency of the transmit filter. */
extern double F_s_BB;           /* Sampling frequency of the baseband signal. */
extern double F_s_PB;           /* Sampling frequency of the passband signal. */
/******************************************************************************/
/*       VARIABLES RELATED TO THE BUFFER CONTAINING THE SYNC PATTERN.
*******************************************************************************/
extern int Event;                             /* 1:Sync obtained;0:otherwise. */
extern int Sync_Inx;                                    /* Sync buffer index. */
extern int Sync_Buf[SYNC_SIZE];                               /* Sync buffer. */
extern int Rx_Sync_Buf[SYNC_SIZE];                 /* Buffer at the receiver. */
/******************************************************************************/
/*                VARIABLES RELATED TO THE ERROR BUFFER.
*******************************************************************************/
extern int Err_Buf_Inx;                                /* Error buffer index. */
extern int Err_Buf[ERR_BUF_SIZE];                            /* Error buffer. */
/******************************************************************************/
/*               VARIABLES RELATED TO THE TRANSMIT-FILTER.
*******************************************************************************/
extern int Symval;                              /* Symbols at Tx. flt. input. */
extern int Tx_D_Fac;                    /* Decimation factor at Tx. Flt. o/p. */
extern int Samp_Phase;             /* Sampling phase chosen for transmission. */
extern double Tx_Op;                                /* Output of the Tx. flt. */
extern double *Tx_Flt;                                      /* Tx. flt. taps. */
extern double *Tx_Reg;                                    /* Tx. flt. memory. */
extern double Tx_Int_Flt[TX_INT_SIZE];             /* Modified Tx. flt. taps. */
extern double Tx_Int_Reg[TX_INT_SIZE];           /* Modified Tx. flt. memory. */
/******************************************************************************/
/*                     VARIABLES RELATED TO THE MODULATOR.
*******************************************************************************/
extern double M_Phase;                           /* Phase due to the message. */
extern double Base_Phase;                  /* Phase state at the transmitter. */
extern double Car_Phase;                         /* Phase due to the carrier. */
extern double Tx_Tot_Phase;                                   /* Total phase. */
extern double Pb_Sig;                           /* Sample of passband signal. */
/******************************************************************************/
/*            VARIABLES RELATED TO THE GAUSSIAN NOISE GENERATOR.
*******************************************************************************/
extern unsigned short n1store[3];                       /* Stores PNS status. */
extern unsigned short n2store[3];                       /* Stores PNS status. */
extern double nvals[NVALSIZE];                   /* Contains U & G rand. var. */
/******************************************************************************/
/*                VARIABLES RELATED TO THE RECEIVER CARRIER.
*******************************************************************************/
extern int My_Cos;                           /* Cosine of the carrier (PI/2). */
extern int My_Sin;                             /* Sine of the carrier (PI/2). */
extern int Delta_Cos;                /* Used to update cosine of the carrier. */
extern int Delta_Sin;                  /* Used to update sine of the carrier. */
extern double Rx_C_Op;                                /* Cosine mixer output. */
extern double Rx_S_Op;                                  /* Sine mixer output. */
/******************************************************************************/
/*                VARIABLES RELATED TO THE LOWPASS FILTER.
*******************************************************************************/
extern double B_t;                                   /* 3-dB of the RC pulse. */
extern double Lpf_Tap[LPF_SIZE];                                 /* LPF taps. */
extern double Lpf_Reg[LPF_SIZE];                               /* LPF memory. */
extern double Delay_Reg[DELAY_REG_SIZE];                   /* Delay register. */
extern double Rx_C_BB;                                    /* Output of delay. */
extern double Rx_S_BB;                                      /* Output of LPF. */
/******************************************************************************/
/*                 VARIABLES RELATED TO THE CORRELATION FILTER.
*******************************************************************************/
extern int Tim_Acq;                         /* 1:Timing acquired;0:otherwise. */
extern int Tim_Inx;                           /* Index corresponding to peak. */
extern int Fst_Samp;         /* Corresponds to lowest tap indices of Tx. Flt. */
extern int Corr_Avg_Inx;                         /* Index to averaging array. */
extern int Corr_Flt_Inx;                         /* Correlation filter index. */
extern double Corr_C_Op;                            /* Re. correlator output. */
extern double Corr_S_Op;                            /* Im. correlator output. */
extern double *Corr_C_Flt;                    /* Re. correlation filter taps. */
extern double *Corr_S_Flt;                    /* Im. correlation filter taps. */
extern double *Corr_C_Reg;                         /* Re. correlation memory. */
extern double *Corr_S_Reg;                         /* Im. correlation memory. */
extern double *Corr_C_Avg;               /* Re. average of correlator output. */
extern double *Corr_S_Avg;               /* Im. average of correlator output. */
/******************************************************************************/
/*                VARIABLES RELATED TO THE ALL "-1" SEQUENCE.
*******************************************************************************/
extern int F_off_Reg_Inx;                          /* Index to the registers. */
extern double Cos_off;                     /* Cosine of current offset phase. */
extern double Sin_off;                       /* Sine of current offset phase. */
extern double F_off_C_Op;                    /* Cosine part of canceller o/p. */
extern double F_off_S_Op;                      /* Sine part of canceller o/p. */
extern double F_off_C_Reg[F_OFF_S_PERIOD];       /* Store cosine of 1 period. */
extern double F_off_S_Reg[F_OFF_S_PERIOD];         /* Store sine of 1 period. */
/******************************************************************************/
/*      VARIABLES RELATED TO STORING SAMPLES THAT ARE INPUT TO THE VA.
*******************************************************************************/
extern int BB_Ipcnt;                  /* Interpolation count in the baseband. */
extern double VA_C_Ip[BB_SAMP];                   /* Cosine part of VA input. */
extern double VA_S_Ip[BB_SAMP];                     /* Sine part of VA input. */
/******************************************************************************/
/*                    VARIABLES RELATED TO THE TRELLIS.
*******************************************************************************/
extern int Mem_Size;                        /* Memory of the transmit-filter. */
extern int Num_States;              /* Number of states in the super-trellis. */
extern int P_State;                          /* Present state in the trellis. */
extern int N_State;                             /* Next state in the trellis. */
extern int P_Input;                                         /* Present input. */
extern int **N_St_Array;                             /* Array of next states. */
extern double **M_C_Array[BB_SAMP];              /* Cosine of message phases. */
extern double **M_S_Array[BB_SAMP];                /* Sine of message phases. */
/******************************************************************************/
/*               VARIABLES RELATED TO THE VITERBI DECODER.
*******************************************************************************/
extern int Depth;                       /* Gives the current depth of the VA. */
extern int VA_Op_Sym;                        /* Symbol number released by VA. */
extern int Max_Wght_St;          /* State associated with the maximum metric. */
extern int Min_Wght_St;          /* State associated with the minimum metric. */
extern double Max_Wght;                                    /* Maximum weight. */
extern double Min_Wght;                                    /* Minimum weight. */
extern double Cur_Wght;                                    /* Current weight. */
extern double New_Re_Wght;                   /* Re. new weight at next state. */
extern double New_Im_Wght;                   /* Im. new weight at next state. */
extern double New_Wght;                                    /* Net new weight. */
extern double Old_Re_Wght;                   /* Re. old weight at next state. */
extern double Old_Im_Wght;                   /* Im. old weight at next state. */
extern double Old_Wght;                                    /* Net old weight. */
struct trellis                                       /* Structure of trellis. */
{
 int *stpath;                                    /* Surviving path of states. */
 int *ippath;                                    /* Surviving path of inputs. */
 double *VA_Re_Wght;                /* Re. metric associated with each state. */
 double *VA_Im_Wght;                /* Im. metric associated with each state. */
 struct trellis *prvdepth;                      /* Address of previous depth. */
 struct trellis *nxtdepth;                          /* Address of next depth. */
};
extern struct trellis *fstdepth,*lstdepth;                      /* Templates. */
/******************************************************************************/
