/******************************************************************************/
/*   Copyright (C) 1996 K. Vasudevan. Indian Institute of Technology Madras.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
/******************************************************************************/
#include "c3type.h"
#include "c3ext.h"
/******************************************************************************/
/*            Get the baseband signal due to an all "-1" sequence.
*******************************************************************************/
int Get_F_Off()
{
 int tmp_sym,tmp_ipcnt,foff_inx;
 foff_inx=ZERO;
 for(tmp_sym=ZERO;tmp_sym<F_OFF_B_PERIOD;tmp_sym++)
 {
  for(tmp_ipcnt=ZERO;tmp_ipcnt<BB_SAMP;tmp_ipcnt++)
   Get_F_Off_Phase(tmp_sym,tmp_ipcnt);
 }
 F_off_Reg_Inx=BB_Ipcnt-Fst_Samp;
 if(F_off_Reg_Inx < ZERO)
  F_off_Reg_Inx=F_off_Reg_Inx+BB_SAMP;
 return(0);
}
/******************************************************************************/
/*                        Get the current phase.
*******************************************************************************/
int Get_F_Off_Phase(tmp_sym,tmp_ipcnt)
int tmp_sym,tmp_ipcnt;
{
 int foff_inx;
 foff_inx=tmp_sym*BB_SAMP+tmp_ipcnt;
 M_Phase= -(double)tmp_sym*PIBY2;
 Get_Minusone_Phase(tmp_ipcnt);
 F_off_C_Reg[foff_inx]=cos(M_Phase);
 F_off_S_Reg[foff_inx]=sin(M_Phase);
 /*printf("%d %lf\n",foff_inx,M_Phase);*/
 return(0);
}
/******************************************************************************/
/*                 Get the phase due to an all "-1" sequence.
*******************************************************************************/
int Get_Minusone_Phase(tmp_ipcnt)
int tmp_ipcnt;
{
 int txinx,arinx,ulimit;
 for(arinx=ONE;arinx<=(Mem_Size+ONE);arinx++)
 {
  ulimit=TWO*Tx_D_Fac*tmp_ipcnt+(Mem_Size+ONE-arinx)*TX_FLT_SAMP;
  ulimit=ulimit+Tim_Inx;
  for(txinx=ZERO;txinx<=ulimit;txinx++)
  {
   if(txinx >= TX_FLT_SIZE)
    exit(13);
   M_Phase=M_Phase-MOD_FAC*Tx_Flt[txinx];
  }
 }
 if(M_Phase < -TWICEPI)
  M_Phase=M_Phase+TWICEPI;
 return(0);
}
/******************************************************************************/
