/******************************************************************************/
/*   Copyright (C) 1996 K. Vasudevan. Indian Institute of Technology Madras.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
/******************************************************************************/
#include "c3type.h"
#include "c3ext.h"
/******************************************************************************/
int Init_Sim()
{
 Init_Sync_Buf_Inx();
 Init_Err_Buf();
 Init_Tx_Flt();
 Init_Mod();
 Init_Noise_Gen();
 Init_Dmod();
 Init_LPF();
 Init_Corr();
 Init_VA();
 return(0);
}
/******************************************************************************/
/*    Initialize the index of the buffer which stores the sync pattern.
*******************************************************************************/
int Init_Sync_Buf_Inx()
{
 int cnt;
 Sync_Inx=SYNC_SIZE-1;
 for(cnt=ZERO;cnt<SYNC_SIZE;cnt++)
  Sync_Buf[cnt]= -TWO;
 for(cnt=ZERO;cnt<SYNC_SIZE;cnt++)
  Rx_Sync_Buf[cnt]=ZERO;
 Event=FALSE;
 return(0);
}
/******************************************************************************/
/*                       Initialize the error buffer.
*******************************************************************************/
int Init_Err_Buf()
{
 for(Err_Buf_Inx=ZERO;Err_Buf_Inx < ERR_BUF_SIZE;Err_Buf_Inx++)
  Err_Buf[Err_Buf_Inx]=ZERO;
 Err_Buf_Inx=ZERO;
 Err_Cnt=ZERO;
 V_Sym_Cnt=ZERO;
 return(0);
}
/******************************************************************************/
/*                  Initialize the transmit filter registers.
*******************************************************************************/
int Init_Tx_Flt()
{
 int cnt;
 for(cnt=ZERO;cnt<TX_FLT_SIZE;cnt++)
  Tx_Reg[cnt]=0.0;
 for(cnt=ZERO;cnt<TX_INT_SIZE;cnt++)
  Tx_Int_Reg[cnt]=0.0;
 Tx_D_Fac=TX_FLT_SAMP/PB_SAMP;
 printf("\t Decimation factor at transmit filter is %d.\n\n",Tx_D_Fac);
 return(0);
}
/******************************************************************************/
/*      Initialize the modulator for coherent/non-coherent reception.
*******************************************************************************/
int Init_Mod()
{
 Base_Phase=Tx_Tot_Phase=0.0;
 Car_Phase=0.0;
 return(0);
}
/******************************************************************************/
/*                     Initialize the noise generator.
*******************************************************************************/
int Init_Noise_Gen()
{
 long int random(void);
 n1store[0]=random();
 n1store[1]=random();
 n1store[2]=random();
 n2store[0]=random();
 n2store[1]=random();
 n2store[2]=random();
 return(0);
}
/******************************************************************************/
/*                       Initialize the demodulator.
*******************************************************************************/
int Init_Dmod()
{
 My_Cos=ONE;
 My_Sin=ZERO;
 Delta_Cos= MINUSONE;                                          /* cos(w_c n). */
 Delta_Sin= MINUSONE;                                         /* -sin(w_c n). */
 return(0);
}
/******************************************************************************/
/*                  Initialize the LPF and delay memory.
*******************************************************************************/
int Init_LPF()
{
 int cnt;
 for(cnt=ZERO;cnt<LPF_SIZE;cnt++)
  Lpf_Reg[cnt]=0.0;
 for(cnt=ZERO;cnt<DELAY_REG_SIZE;cnt++)
  Delay_Reg[cnt]=0.0;
 return(0);
}
/******************************************************************************/
/*                Initialize the correlation registers.
*******************************************************************************/
int Init_Corr()
{
 int cnt;
 for(cnt=ZERO;cnt<CORR_SIZE;cnt++)
 {
  Corr_C_Reg[cnt]=Corr_S_Reg[cnt]=0.0;
  Corr_C_Avg[cnt]=Corr_S_Avg[cnt]=0.0;
 }
 Tim_Acq=FALSE;                                       /* Timing not acquired. */
 Corr_Avg_Inx=ZERO;
 return(0);
}
/******************************************************************************/
/*                         Initialize the VA.
*******************************************************************************/
int Init_VA()
{
 int cnt;
 for(cnt=ZERO;cnt<BB_SAMP;cnt++)
  VA_C_Ip[cnt]=VA_S_Ip[cnt]=0.0;
 BB_Ipcnt=ZERO;
 Depth=ZERO;
 fstdepth=lstdepth=NULL;
 VA_Op_Sym= MINUSONE;
 return(0);
}
/******************************************************************************/
