/******************************************************************************/
/*   Copyright (C) 1996 K. Vasudevan. Indian Institute of Technology Madras.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
/******************************************************************************/
#include "c3type.h"
#include "c3ext.h"
/******************************************************************************/
/*           Get the maximum metric and the associated state.
*******************************************************************************/
int Get_Max_Metric()
{
 int cnt;
 Max_Wght_St=ZERO;
 Max_Wght=lstdepth->VA_Re_Wght[ZERO];
 for(cnt=ONE;cnt<Num_States;cnt++)
 {
  Cur_Wght=lstdepth->VA_Re_Wght[cnt];
  if(Cur_Wght > Max_Wght)
  {
   Max_Wght=Cur_Wght;
   Max_Wght_St=cnt;
  }
 }
 /*Print_Wghts();*/
 return(0);
}
/******************************************************************************/
/*                          Print the weights.
*******************************************************************************/
int Print_Wghts()
{
 int cnt;
 for(cnt=ZERO;cnt<Num_States;cnt++)
  printf("st:%d wght:%f\n",cnt,lstdepth->VA_Re_Wght[cnt]);
 printf("State with max wght:%d wght:%f\n",Max_Wght_St,Max_Wght);
 return(0);
}
/******************************************************************************/
/*                Go backwards and get the last symbol in time.
*******************************************************************************/
int Get_Last_Symbol()
{
 int tstate,tip;
 struct trellis *curr;
 curr=lstdepth;
 tstate=Max_Wght_St;
 /*printf("Backtracking:\n");*/
 while(curr!=NULL)
 {
  tip=curr->ippath[tstate];
  /*printf("currst:%d ip:%d ",tstate,tip);*/
  tstate=curr->stpath[tstate];
  /*printf("Prevst:%d\n",tstate);*/
  curr=curr->prvdepth;
 }
 VA_Op_Sym=tip;                               /* This is the released symbol. */
 /*printf("Released symbol is %d.\n",VA_Op_Sym);*/
 return(0);
}
/******************************************************************************/
/*                           Normalize the metrics.
*******************************************************************************/
int Normalize_Metric()
{
 int cnt;
 for(cnt=ZERO;cnt<Num_States;cnt++)
  lstdepth->VA_Re_Wght[cnt]=lstdepth->VA_Re_Wght[cnt]-Max_Wght;
 return(0);
}
/******************************************************************************/
/*                       Reinitialize Linked List.
*******************************************************************************/
int Linked_List_Reinit()
{
 struct trellis *tnext;
 tnext=fstdepth->nxtdepth;
 tnext->prvdepth=NULL;
 lstdepth->nxtdepth=fstdepth;
 fstdepth->prvdepth=lstdepth;
 fstdepth->nxtdepth=NULL;
 lstdepth=fstdepth;
 fstdepth=tnext;
 return(0);
}
/******************************************************************************/
/*               Reinitialize metrics at the last depth.
*******************************************************************************/
int Metric_Reinit()
{
 int cnt;
 for(cnt=ZERO;cnt<Num_States;cnt++)
  lstdepth->VA_Re_Wght[cnt]= 2*THRESH_WGHT;
 return(0);
}
/******************************************************************************/
