/******************************************************************************/
/*   Copyright (C) 1996 K. Vasudevan. Indian Institute of Technology Madras.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
/* This code generates the theoretical BER vs SNR curve for coherent VA,      */
/* based on the minimum distance error event (MDEE).                          */
/******************************************************************************/
#include <stdio.h>
#include <math.h>
/******************************************************************************/
/*                             SOME CONSTANTS.
*******************************************************************************/
#define FILE_SIZE 128                   /* Maximum characters in a file name. */
#define ERROR 0.00001
/******************************************************************************/
char Inp_File[FILE_SIZE];                          /* Stores input file name. */
int Choice;                                /* 1:continue;0:terminate program. */
double Dist;                                                     /* Distance. */
double Var;                                                /* Noise variance. */
double Snr;                                         /* Signal-to-noise ratio. */
double Ber;                                                /* Bit error rate. */
FILE *fp1;                                                   /* File pointer. */
/******************************************************************************/
main()
{
 Get_File_Name();
 Get_Distance();
 Iterate();
}
/******************************************************************************/
/*                    Get the input file name.
*******************************************************************************/
int Get_File_Name()
{
 printf("Enter file name:");
 scanf("%s",Inp_File);
 printf("You entered filename %s.\n\n",Inp_File);
 fp1=fopen(Inp_File,"w");
 return(0);
}
/******************************************************************************/
/*                         Get the distance.
*******************************************************************************/
Get_Distance()
{
 printf("Enter distance:");
 scanf("%lf",&Dist);
 if(Dist < ERROR)
  Err_Mes(1);
 printf("You entered distance %lf.\n\n",Dist);
 return(0);
}
/******************************************************************************/
/*                                Iterate.
*******************************************************************************/
int Iterate()
{
 printf("Enter choice (1/0):");
 scanf("%d",&Choice);
 while(Choice == 1)
 {
  printf("Enter variance:");
  scanf("%lf",&Var);
  if(Var > ERROR)
  {
   Get_SNR();
   Get_BER();
   Print_Result();
  }
  printf("Enter choice (1/0):");
  scanf("%d",&Choice);
 }
 return(0);
}
/******************************************************************************/
/*                               Get SNR.
*******************************************************************************/
Get_SNR()
{
 Snr=10.0*log10(1.0/Var);
 return(0);
}
/******************************************************************************/
/*                           Get the bit error rate.
*******************************************************************************/
Get_BER()
{
 Ber=0.25*Dist/Var;
 Ber=pow(Ber,0.5);
 Ber=erfc(Ber);
 return(0);
}
/******************************************************************************/
/*                             Print result.
*******************************************************************************/
Print_Result()
{
 printf("SNR:%16.10f BER:%16.10f.\n\n",Snr,Ber);
 fprintf(fp1,"%16.10f %16.10f\n",Snr,Ber);
 return(0);
}
/******************************************************************************/
/*                            Error messages.
*******************************************************************************/
int Err_Mes(num)
int num;
{
 if(num == 1)
  printf("\n\nILLEGAL DISTANCE.\n\n");
 exit(-1);
 return(0);
}
/******************************************************************************/
