/******************************************************************************/
/*   Copyright (C) 1996 K. Vasudevan. Indian Institute of Technology Madras.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
/******************************************************************************/
#include "c5type.h"
#include "c5ext.h"
/******************************************************************************/
/*                       Check the input parameters.
*******************************************************************************/
int Check_Input()
{
 double curr_mod_fac;
 Check_Normalize();
 Check_Tx_Flt();
 Check_LPF();
 return(0);
}
/******************************************************************************/
/*                     Check normalization parameters.
*******************************************************************************/
int Check_Normalize()
{
 if((!NORMALIZE) && (FAC > FAC_THRESH))
  exit(17);
 else if((NORMALIZE) && (FAC < FAC_THRESH))
  exit(17);
 if(PROBE_U_LIM >= NORM_RATE)
  exit(18);
 else if(PROBE_L_LIM <= ZERO)
  exit(18);
 else if(PROBE_U_LIM < PROBE_L_LIM)
  exit(18);
 return(0);
}
/******************************************************************************/
/*                     Check transmit filter parameters.
*******************************************************************************/
int Check_Tx_Flt()
{
 double curr_mod_fac;
 if(TX_FLT_SIZE%TX_FLT_SAMP)
  exit(8);
 curr_mod_fac=TWICEPI*MOD_INX/((double)TX_FLT_SAMP*BIT_RATE);
 if(((MOD_FAC-curr_mod_fac)>ERROR) || ((MOD_FAC-curr_mod_fac)< -ERROR))
  exit(9);
 if(TX_INT_SIZE%PB_SAMP)
  exit(14);
 if((TX_INT_SIZE*TX_FLT_SAMP/PB_SAMP) != TX_FLT_SIZE)
  exit(15);
 return(0);
}
/******************************************************************************/
/*                           Check LPF parameters.
*******************************************************************************/
int Check_LPF()
{
 if(LPF_DELAY%TWO)
  exit(7);
 return(0);
}
/******************************************************************************/
