/******************************************************************************/
/*   Copyright (C) 1996 K. Vasudevan. Indian Institute of Technology Madras.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
/******************************************************************************/
#include "c5type.h"
#include "c5ext.h"
/******************************************************************************/
int Post_Process()
{
 if(lstdepth !=NULL)
  Display_Wghts();
 Print_BER();
 Close_Files();
 return(0);
}
/******************************************************************************/
/*                           Print the weights.
*******************************************************************************/
int Display_Wghts()
{
 int cnt;
 double mag;
 struct trellis *prev;
 prev=lstdepth->prvdepth;
 for(cnt=ZERO;cnt < Num_States;cnt++)
 {
  mag=prev->VA_Re_Wght[cnt]*prev->VA_Re_Wght[cnt];
  mag=mag+prev->VA_Im_Wght[cnt]*prev->VA_Im_Wght[cnt];
  printf("State:%2d Re. wght:%+12.6f ",cnt,prev->VA_Re_Wght[cnt]);
  printf("Im. wght:%+12.6f Mag:%16.10f\n\n",prev->VA_Im_Wght[cnt],mag);
 }
 return(0);
}
/******************************************************************************/
/*                    Print the BER and probing errors.
*******************************************************************************/
int Print_BER()
{
 double frac_probe_errors;
 printf("\t No. of bit errors is %d.\n\n",Err_Cnt);
 printf("\t No. of valid bits is %d.\n\n",V_Sym_Cnt);
 frac_probe_errors=(double)Probe_Err_Cnt/(double)Probe_Cnt;
 printf("\t Fraction of errors between %d and ",PROBE_L_LIM);
 printf("%d bits is %lf.\n\n",PROBE_U_LIM,frac_probe_errors);
 return(0);
}
/******************************************************************************/
/*                          Close all the files.
*******************************************************************************/
int Close_Files()
{
 fclose(fp1);
 fclose(fp2);
 fclose(fp3);
 fclose(fp4);
 fclose(fp5);
 fclose(fp6);
 fclose(fp7);
 return(0);
}
/******************************************************************************/
