/******************************************************************************/
/*   Copyright (C) 1996 K. Vasudevan. Indian Institute of Technology Madras.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
/******************************************************************************/
/*                        FILE POINTER VARIABLES.
*******************************************************************************/
extern FILE *fp1,*fp2;                                      /* File pointers. */
/******************************************************************************/
/*              VARIABLES RELATED TO THE SAMPLING FREQUENCY.
*******************************************************************************/
extern double F_s_Tx_Flt;       /* Sampling frequency of the transmit filter. */
extern double F_s_BB;           /* Sampling frequency of the baseband signal. */
extern double F_s_PB;           /* Sampling frequency of the passband signal. */
/******************************************************************************/
/*               VARIABLES RELATED TO THE TRANSMIT-FILTER.
*******************************************************************************/
extern int Tx_D_Fac;                    /* Decimation factor at Tx. Flt. o/p. */
extern double Tx_Flt[TX_FLT_SIZE];                          /* Tx. flt. taps. */
/******************************************************************************/
/*                     VARIABLES RELATED TO THE MODULATOR.
*******************************************************************************/
extern double M_Phase;                           /* Phase due to the message. */
/******************************************************************************/
/*                    VARIABLES RELATED TO THE TRELLIS.
*******************************************************************************/
extern int Mem_Size;                        /* Memory of the transmit-filter. */
extern int Num_States;              /* Number of states in the super-trellis. */
extern int P_State;                          /* Present state in the trellis. */
extern int N_State;                             /* Next state in the trellis. */
extern int P_Input;                                         /* Present input. */
extern int **N_St_Array;                             /* Array of next states. */
extern double **M_C_Array[BB_SAMP];              /* Cosine of message phases. */
extern double **M_S_Array[BB_SAMP];                /* Sine of message phases. */
/******************************************************************************/
/*                   VARIABLES RELATED TO THE SEARCH.
*******************************************************************************/
extern int Depth;                                           /* Current depth. */
extern int Pre_Input;                                       /* Present input. */
extern int Pre_State;                                       /* Present state. */
extern int Nxt_State;                                          /* Next state. */
extern int Prv_State;                                      /* Previous state. */
extern int *Err_Cnt[MAX_D_M1];       /* Error count for each state and depth. */
extern int *Prv_St_Array[MAX_D_M1];                 /* Used for backtracking. */
/******************************************************************************/
/*            VARIABLES RELATED TO PROPAGATION OF CORRELATIONS.
*******************************************************************************/
extern double Sq_Mag;            /* Squared magnitude of metric on remerging. */
extern double Mag;                       /* Magnitude of metric on remerging. */
extern double *Re_Wght[MAX_DEPTH];      /* Im. wght for each state and depth. */
extern double *Im_Wght[MAX_DEPTH];      /* Im. wght for each state and depth. */
/******************************************************************************/
/*               VARIABLES RELATED TO THE REFERENCE SEQUENCE.
*******************************************************************************/
extern int Max_Ref_Seq;                        /* Max. no. of ref. sequences. */
extern int Ref_Seq_Num;                         /* Reference sequence number. */
extern int Ref_Bin_Seq[MAX_D_M1];          /* Ref. sequence number in binary. */
extern int Ref_Nxt_State[MAX_D_M1];         /* Seq. of states visited by ref. */
extern double Ref_C_Op[MAX_D_M1][BB_SAMP];              /* Re. output of ref. */
extern double Ref_S_Op[MAX_D_M1][BB_SAMP];              /* Im. output of ref. */
/******************************************************************************/
/*               VARIABLES RELATED TO THE DISTANCE SPECTRUM.
*******************************************************************************/
extern int Dist_Store_Inx;                /* Index to the array of distances. */
extern int Dist_Mult[MAX_NUM_DIST];                 /* Contains multiplicity. */
extern double Dist_Store[MAX_NUM_DIST];                   /* Store distances. */
/******************************************************************************/
