/******************************************************************************/
/*   Copyright (C) 1996 K. Vasudevan. Indian Institute of Technology Madras.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
/******************************************************************************/
/*                        FILE POINTER VARIABLES.
*******************************************************************************/
FILE *fp1,*fp2;                                             /* File pointers. */
/******************************************************************************/
/*              VARIABLES RELATED TO THE SAMPLING FREQUENCY.
*******************************************************************************/
double F_s_Tx_Flt;              /* Sampling frequency of the transmit filter. */
double F_s_BB;                  /* Sampling frequency of the baseband signal. */
double F_s_PB;                  /* Sampling frequency of the passband signal. */
/******************************************************************************/
/*               VARIABLES RELATED TO THE TRANSMIT-FILTER.
*******************************************************************************/
int Tx_D_Fac;                           /* Decimation factor at Tx. Flt. o/p. */
double Tx_Flt[TX_FLT_SIZE];                                 /* Tx. flt. taps. */
/******************************************************************************/
/*                     VARIABLES RELATED TO THE MODULATOR.
*******************************************************************************/
double M_Phase;                                  /* Phase due to the message. */
/******************************************************************************/
/*                    VARIABLES RELATED TO THE TRELLIS.
*******************************************************************************/
int Mem_Size;                               /* Memory of the transmit-filter. */
int Num_States;                     /* Number of states in the super-trellis. */
int P_State;                                 /* Present state in the trellis. */
int N_State;                                    /* Next state in the trellis. */
int P_Input;                                                /* Present input. */
int **N_St_Array;                                    /* Array of next states. */
double **M_C_Array[BB_SAMP];                     /* Cosine of message phases. */
double **M_S_Array[BB_SAMP];                       /* Sine of message phases. */
/******************************************************************************/
/*                   VARIABLES RELATED TO THE SEARCH.
*******************************************************************************/
int Depth;                                                  /* Current depth. */
int Pre_Input;                                              /* Present input. */
int Pre_State;                                              /* Present state. */
int Nxt_State;                                                 /* Next state. */
int Prv_State;                                             /* Previous state. */
int *Err_Cnt[MAX_D_M1];              /* Error count for each state and depth. */
int *Prv_St_Array[MAX_D_M1];                        /* Used for backtracking. */
/******************************************************************************/
/*            VARIABLES RELATED TO PROPAGATION OF CORRELATIONS.
*******************************************************************************/
double Sq_Mag;                   /* Squared magnitude of metric on remerging. */
double Mag;                              /* Magnitude of metric on remerging. */
double *Re_Wght[MAX_DEPTH];             /* Im. wght for each state and depth. */
double *Im_Wght[MAX_DEPTH];             /* Im. wght for each state and depth. */
/******************************************************************************/
/*               VARIABLES RELATED TO THE REFERENCE SEQUENCE.
*******************************************************************************/
int Max_Ref_Seq;                               /* Max. no. of ref. sequences. */
int Ref_Seq_Num;                                /* Reference sequence number. */
int Ref_Bin_Seq[MAX_D_M1];                 /* Ref. sequence number in binary. */
int Ref_Nxt_State[MAX_D_M1];                /* Seq. of states visited by ref. */
double Ref_C_Op[MAX_D_M1][BB_SAMP];                     /* Re. output of ref. */
double Ref_S_Op[MAX_D_M1][BB_SAMP];                     /* Im. output of ref. */
/******************************************************************************/
/*               VARIABLES RELATED TO THE DISTANCE SPECTRUM.
*******************************************************************************/
int Dist_Store_Inx;                       /* Index to the array of distances. */
int Dist_Mult[MAX_NUM_DIST];                        /* Contains multiplicity. */
double Dist_Store[MAX_NUM_DIST];                          /* Store distances. */
/******************************************************************************/
