/******************************************************************************/
/*   Copyright (C) 1996 K. Vasudevan. Indian Institute of Technology Madras.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
/******************************************************************************/
#include "dstype.h"
#include "dsext.h"
/******************************************************************************/
int Init_Search()
{
 Init_Err_Cnt();
 Init_Wght();
 Init_Dist_Store();
 Init_Gen_Var();
 return(0);
}
/******************************************************************************/
/*       Initialize the error count for each state at each depth.
*******************************************************************************/
int Init_Err_Cnt()
{
 int cnt1,cnt2;
 for(cnt1=ZERO;cnt1<MAX_D_M1;cnt1++)
 {
  for(cnt2=ZERO;cnt2<Num_States;cnt2++)
   Err_Cnt[cnt1][cnt2]=ZERO;
 }
 Err_Cnt[ZERO][ZERO]=ONE;
 Pre_Input=Err_Cnt[ZERO][ZERO]^Ref_Bin_Seq[ZERO];
 return(0);
}
/******************************************************************************/
/*               Initialize the weight for the starting state.
*******************************************************************************/
int Init_Wght()
{
 Re_Wght[ZERO][ZERO]=Im_Wght[ZERO][ZERO]=0.0;
 return(0);
}
/******************************************************************************/
/*                      Initialize the distance store.
*******************************************************************************/
int Init_Dist_Store()
{
 int cnt;
 for(cnt=ZERO;cnt<MAX_NUM_DIST;cnt++)
  Dist_Store[cnt]= THRESH_WGHT;
 for(cnt=ZERO;cnt<MAX_NUM_DIST;cnt++)
  Dist_Mult[cnt]=ZERO;
 Dist_Store_Inx=ZERO;
 return(0);
}
/******************************************************************************/
/*                    Initialize the general variables.
*******************************************************************************/
int Init_Gen_Var()
{
 Depth=Pre_State=ZERO;
 return(0);
}
/******************************************************************************/
