/******************************************************************************/
/*   Copyright (C) 1996 K. Vasudevan. Indian Institute of Technology Madras.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
/******************************************************************************/
#include <stdio.h>
#include <math.h>
/******************************************************************************/
/*                            DEPTH OF SEARCH.
*******************************************************************************/
#define MAX_DEPTH 10
#define MAX_D_M1 (MAX_DEPTH-1)
/******************************************************************************/
/*                          GRAPHICS PARAMETERS.
*******************************************************************************/
#define PRN_SEQ_NUM 0     /* Ref. seq. no. whose spectrum is to be printed. */
/******************************************************************************/
/*                           GENERAL PARAMETERS.
*******************************************************************************/
#define PB_SAMP 4                         /* Samples per bit in the passband. */
#define BB_SAMP 2                         /* Samples per bit in the baseband. */
#define TX_FLT_SAMP 96                /* Samples per bit for transmit filter. */
#define D_FAC (PB_SAMP/BB_SAMP)                         /* Decimation factor. */
#define BIT_RATE 1.152                                           /* Bit-rate. */
#define BW_3_DB (0.5*BIT_RATE)       /* 3-dB bandwidth of the Gaussian pulse. */
#define MOD_INX 0.5                                      /* Modulation index. */
#define CONSTELL_SIZE 2                                 /* Binary signalling. */
#define COHERENT 1                       /* 1:Coherent reception;0:otherwise. */
/******************************************************************************/
/*                      TRANSMIT FILTER PARAMETERS.
*******************************************************************************/
#define G_FLT_SIZE 193                           /* Order of Gaussian filter. */
#define TX_FLT_SIZE (G_FLT_SIZE+TX_FLT_SAMP-1)           /* Order of Tx. flt. */
/******************************************************************************/
/*                          SEARCH PARAMETERS.
*******************************************************************************/
#define MAX_NUM_DIST 1600                     /* Maximum number of distances. */
#define THRESH_WGHT (-10000.0)                         /* Coherent threshold. */
/******************************************************************************/
/*                             CONSTANTS.
*******************************************************************************/
#define BINSIZE 16         /* Size of array to store states in binary format. */
#define TWO 2
#define ONE 1
#define ZERO 0
#define TRUE 1
#define FALSE 0
#define LEFT 0
#define RIGHT 1
#define MINUSONE (-1)
#define ERROR 0.0001
#define PI 3.14159265358979323846
#define PIBY2 1.57079632679489661923
#define TWICEPI 6.28318530717958647692
/*#define MOD_FAC 0.05681410325502374924*/    /* 2*PI*MOD_INX/F_s_Tx_Flt;48R. */
#define MOD_FAC 0.02840705162751187462                        /* For 96R. */
/******************************************************************************/
