/******************************************************************************/
/*   Copyright (C) 1996 K. Vasudevan. Indian Institute of Technology Madras.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
/******************************************************************************/
#include "dstype.h"
#include "dsext.h"
/******************************************************************************/
/*               Convert state from decimal to binary format.
*******************************************************************************/
int Decimal_to_Binary(array,size,input)
int array[],size,input;
{
 int cnt;
 for(cnt=ZERO;cnt<size;cnt++)
  array[cnt]=ZERO;
 cnt=ZERO;
 while(input > ZERO)
 {
  if(cnt == size)
   Error_Mes(2);
  array[cnt]=input%TWO;
  input=input/TWO;
  cnt++;
 }
 /*printf("P_State:%d Binary format:",P_State);
 for(cnt=size-1;cnt>=ZERO;cnt--)
  printf("%d",array[cnt]);
 printf("\n\n");*/
 return(0);
}
/******************************************************************************/
/* a) Get the phase sequence corresponding to the reference sequence.
   b) Get the state sequence corresponding to the reference sequence.
*******************************************************************************/
int Get_Reference_Seq()
{
 int t_depth,inp,samp_phase;
 Pre_State=ZERO;
 for(t_depth=ZERO;t_depth<MAX_D_M1;t_depth++)
 {
  inp=Ref_Bin_Seq[t_depth];
  for(samp_phase=ZERO;samp_phase<BB_SAMP;samp_phase++)
  {
   Ref_C_Op[t_depth][samp_phase]=M_C_Array[samp_phase][Pre_State][inp];
   Ref_S_Op[t_depth][samp_phase]=M_S_Array[samp_phase][Pre_State][inp];
  }
  Ref_Nxt_State[t_depth]=N_St_Array[Pre_State][inp];
  Pre_State=N_St_Array[Pre_State][inp];
 }
 return(0);
}
/******************************************************************************/
/* Input arrays: ip1[losize] is smaller array.ip2[hisize] is larger array.
   Output array: op[].
*******************************************************************************/
int Convolve(ip1,ip2,op,losize,hisize)
int losize,hisize;
double ip1[],ip2[],op[];
{
 int opcnt,ipcnt,loop;
 for(opcnt=ZERO;opcnt<(losize+hisize-1);opcnt++)
 {
  op[opcnt]=0.0;
  ipcnt=ZERO;
  loop=TRUE;
  while((ipcnt<losize)&&(loop==TRUE))
  {
   if((opcnt-ipcnt)<ZERO)
    loop=FALSE;
   else if((opcnt-ipcnt)>=hisize)
    ipcnt=opcnt-hisize+1;
   else
   {
    op[opcnt]=op[opcnt]+ip1[ipcnt]*ip2[opcnt-ipcnt];
    ipcnt++;
   }
  }
 }
 return(0);
}
/******************************************************************************/
/*                             Error message.
*******************************************************************************/
int Error_Mes(num)
int num;
{
 fprintf(stdout,"\t Simulation error. Exiting with code %d.\n\n",num);
 fflush(stdout);
 exit(num);
 return(0);
}
/******************************************************************************/
